<?php

namespace Drupal\teamtailor;

use Drupal\Core\Config\ConfigFactory;

/**
 * @TODO: add comment.
 */
class TeamtailorController {
  
  private $apiKey;
  private $client;
  protected $configFactory;
  /**
   * @TODO: add comment.
   */
  public function __construct(ConfigFactory $configFactory) {
    $this->configFactory = $configFactory;
    $this->client = \Drupal::httpClient();
    $this->setApiKey();
  }

  /**
   * @TODO: complete this.
   */
  private function setApiKey() {
    $this->apiKey = $this->configFactory->get('teamtailor.settings')->get('api_key');
    $this->apiVersion = $this->configFactory->get('teamtailor.settings')->get('api_version');
  }

  public function getData() {
    $jobs = $this->getJobs();
    $jobs_data = [];
    foreach ($jobs->data as $job) {
      $job_object = (array) $this->getJob($job->id)->data->attributes;
      $jobs_data[$job->id]['job'] = $job_object;
      $candidates_data = $this->getCandidates($job->id);
      $candidate = [];
      foreach ($candidates_data->data as $cand) {
        $candidate[$cand->id] = (array) $cand->attributes;
        $role = $this->getUserRole($cand->id);
        $candidate[$cand->id]['role'] = $role;

      }
      $jobs_data[$job->id]['candidates'] = $candidate;
    }
    return $jobs_data;
  }

  public function getUserRole($id) {
    $url = 'https://api.teamtailor.com/v1/candidates/' . $id . '/relationships/role';

    return $this->apiCall($url);
  }

  public function getCandidates($job_id = FALSE) {
    if ($job_id) {
      $url = 'https://api.teamtailor.com/v1/jobs/' . $job_id . '/candidates';
    }
    else {
      $url = 'https://api.teamtailor.com/v1/candidates';
    }
    return $this->apiCall($url);
  }

  public function getJob($id) {
    $url = 'https://api.teamtailor.com/v1/jobs/' . $id;

    return $this->apiCall($url);
  }

  /**
   * @TODO: complete this.
   */
  public function getJobs() {
    $url = "https://api.teamtailor.com/v1/jobs?include=department,locations";

    return $this->apiCall($url);
  }

  /**
   * Api call.
   */
  private function apiCall($url, $method = 'GET') {
    try {
      $path = $url;
      $request = $this->client->request($method, $path, [
        'headers' => [
          'Authorization' => 'Token token=' . $this->apiKey,
          'X-Api-Version' => $this->apiVersion,
        ],
      ]);
      $file_contents = $request->getBody()->getContents();
      $result = json_decode($file_contents);
    }
    catch (ClientException $exception) {
      $result = [];
    }
    return $result;
  }
}
